#! /usr/bin/perl
#
# Add Turns (Hourly Run)
# Copyright (c) 1999 PC Purgett

#use FCGI;
#require "/etc/cron.hourly/email.cgi";
require "/home/prom1/master.cgi";

$userdir = "/home/prom1data";
$playerdb = "Players";
$newsdb = "News1";
$infmkt = "InfMkt1";
$tnkmkt = "TnkMkt1";
$helmkt = "HelMkt1";

use Mysql;
$db = Mysql->connect(localhost,Promisance,"prom","morP");

($sec,$min,$hour,$day,$mon,$year,$wday,$yday,$isdst) = localtime(time);
if ($year >= 100) { $year -= 100; }
@months = ("01","02","03","04","05","06","07","08","09","10","11","12");
$datetime = sprintf("%02d-%02d-%02d %02d:%02d:%02d", $months[$mon],$day,$year,$hour,$min,$sec);

        open(confg, "$userdir/config");
        $config = <confg>;
        close(confg);
        @cpairs = split(/&/, $config);
        foreach $cpair (@cpairs) {
                ($name, $value) = split(/=/, $cpair);
                $value =~ tr/+/ /;
                $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
                $config{$name} = $value;
            $value =~ s/<!--(.|\n)*-->//g;
        }

open(trn,"$userdir/turns");
$turns = <trn>;
close(trn);

if ($turns < 50) {
	$turns += 2;
	open(trn,">$userdir/turns");
	print trn "$turns";
	close(trn);
}

open(food,">$userdir/food.price");
$food = int(rand(6));
if ($food < 3) { $food = 3; }
print food "$food";
close(food);

my $dbu = $db->Query("SELECT num FROM $playerdb order by num;");
my @yomama = $dbu->fetchcol(0);
$db->Query("update $playerdb set turns=(turns + 1) where vacation <= 0 and turns < 135;");
$db->Query("update $playerdb set vacation=(vacation - 1) where vacation >= 1;");
$db->Query("update $playerdb set infantry=0 where infantry<0;");
$db->Query("update $playerdb set tanks=0 where tanks<0;");
$db->Query("update $playerdb set helis=0 where helis<0;");
        
$run = 0;
open(TEST,">>$userdir/turns.log");
while (my $who = shift @yomama) {
        my %users = $db->Query("select * from $playerdb where num=$who")->fetchhash();
	$networth = int(($users{'infantry'} * 1.5) + ($users{'infantry2'} * 2) +
($users{'infantry3'} * 2.75) + ($users{'tanks'} * 1.5) + ($users{'tanks2'} * 2) +
($users{'tanks3'} * 2.75) + ($users{'helis'} * 4) + ($users{'helis2'} * 6) +
($users{'helis3'} * 7.75) + ($users{'spies'} * 2) + ($users{'spies2'} * 3.75) +
($users{'spies3'} * 4.67) + ($users{'land'} * 95) + ($users{'peasants'}) + ($users{'cash'}
/ 10000) + ($users{'food'} / 2000) + ($users{towers} * 10) + ($users{wizards} * 2) +
($users{ships} * 5));
        
	print TEST "[$datetime] $who\n";
        if (($networth > 0) && ($networth <= 100000)) { $size = .324; }
        if (($networth > 100000) && ($networth <= 500000)) { $size = .587; }
        if (($networth > 500000) && ($networth <= 1000000)) { $size = 1.345; }
        if (($networth > 1000000) && ($networth <= 10000000)) { $size = 1.894; }
        if (($networth > 10000000) && ($networth <= 100000000)) { $size = 2.454; }
        if ($networth > 100000000) { $size = 3.574; }
        if (($hour == 0) && ($min <= 20) && ($run eq "0") && ($firstweek eq "0")) {
		$users{daysidle} += 1;
		srand(time);
		$peoplea = $db->Query("select num from $playerdb;")->numrows;
		$people = $peoplea * 6;
                $lotterynum = int(rand($people));
                open(LOTTLOG,">>$userdir/lottery.log");
                print LOTTLOG "$people - $lotterynum [$datetime]\n";
		close(LOTTLOG);
		$run = "1";
                $dbl = $db->Query("select * from $playerdb where ticket=$lotterynum");
                %winner = $dbl->FetchHash;
		if ($winner{empire}) {
                	open(jackpot,"$userdir/jackpot.amount");
                	$jackpot = <jackpot>;
                	close(jackpot);
			if ($winner{num} < $peoplea) {
	        	        open(jackpota,">$userdir/jackpot.amount");
	        	        print jackpota "50000000";
	        	        close(jackpota);
				open(winner,">$userdir/lottery.winner");
				print winner "$winner{empire} \(\#$winner{num}\)";
				close(winner);
			} else {
				unlink("$userdir/lottery.winner");
			}
                	open(message, ">>$userdir/users/$winner{num}.news");
			@mesg[0] = "At <b>$datetime</b>, you look at your lottery ticket and the winning ticket, they match!  You have won \$$jackpot!<br>\n";
                	print message @mesg;
                	close(message);
                	$winners{cash} += $jackpot;
                	$db->Query("update $playerdb set cash=$winners{cash} where num=$winner{num};");
			$db->Query("update $playerdb set ticket=0,lottery=0;");
		} else {
			unlink("$userdir/lottery.winner");
		}
		$db->Query("delete from $playerdb where daysidle>=14 and vacation<=0;");
		if ($day > 4) {
			$deleteday = $day - 4;
			$db->Query("delete from $newsdb where month=$mon;");
			$db->Query("delete from $newsdb where month=$months[$mon] and date<=$deleteday;");
		}
		$run = "1";
	  }
	if ($min <= 24) {
		$db->Query("update $infmkt set hours=(hours + 1) where num=$who;");
		$db->Query("update $tnkmkt set hours=(hours + 1) where num=$who;");
		$db->Query("update $helmkt set hours=(hours + 1) where num=$who;");
		$db->Query("update $playerdb set shield=(shield - 1) where num=$who;");
		$db->Query("update $playerdb set gate=(gate - 1) where num=$who;");
		$db->Query("update $playerdb set lottery=(lottery - 1) where num=$who;");
	        if ($users{offense} > 0) { $users{offense} -= 1; }
	        if ($users{vacation} > 1) { $users{vacation} += 1; }
		$db->Query("update $playerdb set allytime=(allytime + 1) where num=$who;");
	        $loanrate = $config{'loanbase'} + $size;
	        $users{'loan'} = $users{'loan'} + (int($users{'loan'} * ($loanrate / 100)));
	        if (($users{'turnsused'} > 100) || ($users{'savings'} <= ($networth * 5))) {
		        $savrate = $config{'savebase'} - $size;
		        $users{'savings'} = $users{'savings'} + int($users{'savings'} * ($savrate / 100));
		        if ($users{savings} > ($networth * 5)) { $users{savings} = $networth * 5; }
		        if ($users{loan} > ($networth * 5)) { $users{loan} = $networth * 5; }
		}
	}
        $users{free} = 1;
        foreach $key (keys %users) {
                if ($users{$key} < 0) { $users{$key} = 0; }
        }
        if ($users{'turns'} > 135) {$users{'turns'} = 135; }
        
	$db->Query("UPDATE $playerdb set networth='$networth',password='$users{password}',email='$users{email}',state='$users{state}',name='$users{name}',empire='$users{empire}',race='$users{race}',turns='$users{turns}',freeland='$users{freeland}',attacks='$users{attacks}',savings='$users{savings}',loan='$users{loan}',gate='$users{gate}',shield='$users{shield}',vacation='$users{vacation}',daysidle='$users{daysidle}' where num=$who;");
};

close(TEST);
